#!/bin/sh
# term_display - run a command in a new xterm.

myname=`basename $0`
usage () {
# TRANSLATE quoted string after echo command
echo "
用法: $myname {USE_MORE | NO_MORE} command-invocation
       USE_MORE: 'more' を使用して出力をパイプする場合
       NO_MORE:  出力を直接表示する場合

EV ATRIA_TERM_INTRO を設定して､コマンドを実行する前に
メッセージを表示できます。例
    検索しています...
"
    exit 1
}

trap 'rm -f /tmp/termdisp.$$; exit 1' 1 2 3 9 15

rm -f /tmp/termdisp.$$

if [ "$1" = "USE_MORE" ] ; then
    USE_MORE=1
elif [ "$1" = "NO_MORE" ] ; then
    USE_MORE=0
else
    # TRANSLATE quoted string after echo command
    echo "$0 用法のエラー。最初の引数は､USE_MORE または NO_MORE である必要があります。"
    exit 1
fi
shift

#------------- Script run by xterm -------------

cat <<! >/tmp/termdisp.$$
#!/bin/sh
# TRANSLATE quoted string after echo command
trap 'sleep 1; echo 1>&2; echo "終了するには <CR> と入力してください。" 1>&2; read xxx; exit 1' 1 2 3 9 15
# RATLC01091113 - AIX has a problem with passing the $NLSPATH environment
# variable to the dtterm in which the command is run. Setting it explicitly
# to ensure we have the right value for $NLSPATH.
export NLSPATH=$NLSPATH

# SGI xwsh doesn't inherit stty settings (without .wshttymodestty)
# so you can't quit out of commands. We compensate by setting 'intr' to ^C
#
if [ "$XC_EXEC_NAME" = "xwsh" ] ; then
    if [ ! -r $HOME/.wshttymodestty ] ; then
	stty intr '^C' 2>/dev/null
    fi
fi

if [ "$ATRIA_TERM_INTRO" != "" ] ; then
    echo "$ATRIA_TERM_INTRO"
    echo
fi

if [ $USE_MORE = 1 ] ; then
    $* 2>&1 | more
else
    $*
fi

echo
# TRANSLATE quoted string after echo command
echo "終了するには <CR> と入力してください。"
read xxx
!

#-----------------------------------------------

chmod +x /tmp/termdisp.$$
if [ "$ATRIA_DEBUG_BUTTON" != "" ] ; then
    echo "-------------------"
    echo "/tmp/termdisp.$$"
    cat /tmp/termdisp.$$
    echo "-------------------"
else
    if [ "$XC_SCROLLBAR_FLAG" != "" ] ; then
        MORE_XC_ARGS="$XC_SCROLLBAR_FLAG"
        if [ "$XC_SCROLLBAR_ARG" != "" ] ; then
            MORE_XC_ARGS="$MORE_XC_ARGS $XC_SCROLLBAR_ARG"
        fi
    fi
    if [ "$XC_SAVE_LINES_FLAG" != "" ] ; then
        MORE_XC_ARGS="$MORE_XC_ARGS $XC_SAVE_LINES_FLAG 500"
    fi
#
# Japanese terminal support
#
    if [ "$LANG" != "" -a "$XC_EXEC_NAME" = "xterm" ]; then
	LANG_PREFIX=`echo $LANG | cut -c 1,2 | tr '[A-Z]' '[a-z]'`
	if [ "$LANG_PREFIX" = "ja" -o "$LANG_PREFIX" = "jp" ]; then
	    # find kanji terminal command
	    kanji_term_cmd=`type gnome-terminal 2> /dev/null | awk '{ print $NF }'`
	    if [ "$kanji_term_cmd" != "" ]; then
		TERM_FLAG="--disable-factory"
		MORE_XC_ARGS=""
	    else
		kanji_term_cmd=`type aterm 2> /dev/null | awk '{ print $NF }'`	    
		if [ "$kanji_term_cmd" = "" ]; then
		    kanji_term_cmd=`type kterm 2> /dev/null | awk '{ print $NF }'`
		    LANG_SUFFIX=`echo $LANG | cut -c 7,8,9,10| tr '[A-Z]' '[a-z]'`
		    ORIG_LANG_PREFIX=`echo $LANG | cut -c 1,2`
		    if [ "$LANG_SUFFIX" = "sjis" -o "$ORIG_LANG_PREFIX" = "Ja" ]; then
			TERM_FLAG="-km sjis"
		    else
			TERM_FLAG="-km euc"
		    fi
		fi
	    fi
	    if [ "$kanji_term_cmd" != "" ]; then
		XC_EXEC_PNAME=$kanji_term_cmd; export XC_EXEC_PNAME
	    else
		TERM_FLAG=""
	    fi
	fi
    fi

    if [ $XC_EXEC_NAME = "cmdtool" ] ; then
	# need an extra 'exit' because cmdtool runs a shell
	($XC_EXEC_PNAME $TERM_FLAG $MORE_XC_ARGS $XC_COMMAND_FLAG "/tmp/termdisp.$$;exit" ; rm -f /tmp/termdisp.$$) &
    else
	# xterm and xwsh just run argument -- no extra shell
	($XC_EXEC_PNAME $TERM_FLAG $MORE_XC_ARGS $XC_COMMAND_FLAG /tmp/termdisp.$$ ; rm -f /tmp/termdisp.$$) &
    fi
fi

